#
# NDK build file
#
# Written by Ant-ON, 2021
#

LOCAL_PATH := $(call my-dir)
include $(CLEAR_VARS)

LOCAL_MODULE := cryptsetup-2.3

LOCAL_C_INCLUDES := $(LOCAL_PATH) \
	$(LOCAL_PATH)/include \
	$(LOCAL_PATH)/src \
	$(LOCAL_PATH)/src/luks1 \
	$(LOCAL_PATH)/src/luks2 \
	$(LOCAL_PATH)/src/crypto_backend \
	$(LOCAL_PATH)/src/integrity \
	$(LOCAL_PATH)/src/loopaes \
	$(LOCAL_PATH)/src/tcrypt \
	$(LOCAL_PATH)/src/verity \
	$(LOCAL_PATH)/src/bitlk

LOCAL_SRC_FILES := \
	bdevice.c \
	cryptsetup-java.c \
	libdevmapper.c \
	uuid.c \
	utf8_16.c \
	utils.c \
	crypto_mbedtls.c \
	cipher_check_mbedtls.c \
	src/setup.c \
	src/utils.c \
	src/utils_benchmark.c \
	src/utils_crypt.c \
	src/utils_fips.c \
	src/utils_keyring.c \
	src/utils_pbkdf.c \
	src/utils_safe_memory.c \
	src/volumekey.c \
	src/random.c \
	src/crypt_plain.c \
	src/base64.c \
	src/bitlk/bitlk.c \
	src/luks1/af.c \
	src/luks1/keyencryption.c \
	src/luks1/keymanage.c \
	src/luks2/luks2_disk_metadata.c \
	src/luks2/luks2_json_format.c \
	src/luks2/luks2_json_metadata.c \
	src/luks2/luks2_digest.c \
	src/luks2/luks2_digest_pbkdf2.c \
	src/luks2/luks2_keyslot.c \
	src/luks2/luks2_keyslot_luks2.c \
	src/luks2/luks2_segment.c \
	src/luks2/luks2_token_keyring.c \
	src/luks2/luks2_token.c \
	src/luks2/luks2_reencrypt.c \
	src/luks2/luks2_keyslot_reenc.c \
	src/luks2/luks2_luks1_convert.c \
	src/tcrypt/tcrypt.c \
	src/integrity/integrity.c \
	src/verity/rs_decode_char.c \
	src/verity/rs_encode_char.c \
	src/verity/verity.c \
	src/verity/verity_fec.c \
	src/verity/verity_hash.c \
	src/loopaes/loopaes.c \
	src/utils_blkid.c \
	src/crypto_backend/crypto_cipher_kernel.c \
	src/crypto_backend/crypto_storage.c \
	src/crypto_backend/pbkdf_check.c \
	src/crypto_backend/crc32.c \
	src/crypto_backend/argon2_generic.c \
	src/crypto_backend/cipher_generic.c \
	src/crypto_backend/argon2/blake2/blake2b.c \
	src/crypto_backend/argon2/argon2.c \
	src/crypto_backend/argon2/core.c \
	src/crypto_backend/argon2/encoding.c \
	src/crypto_backend/argon2/ref.c

MAIN_CFLAGS :=  \
	--include='config.h' \
	-DARGON2_NO_THREADS -DANDROID_JNI -DAND_MAX_FD=3

LOCAL_CFLAGS += -Wall -O2 $(MAIN_CFLAGS)

# LTO
LOCAL_CFLAGS += -fuse-linker-plugin -flto
LOCAL_LDFLAGS += -fuse-linker-plugin -flto

# Remove unused code
#LOCAL_CFLAGS += -fvisibility=hidden -ffunction-sections -fdata-sections -Wl,--gc-sections
#LOCAL_CPPFLAGS += -fvisibility=hidden -fvisibility-inlines-hidden -ffunction-sections -fdata-sections -Wl,--gc-sections
#LOCAL_LDFLAGS += -Wl,--gc-sections -Wl,--strip-all -Wl,-z,nocopyreloc

# Disable STB_GNU_UNIQUE symbol binding
LOCAL_CFLAGS += -Wl,-no-gnu-unique
LOCAL_LDFLAGS += -fuse-ld=gold -Wl,-no-gnu-unique

LOCAL_SHARED_LIBRARIES := mbedtls-2.25.0 bm-1.0 libjson-0.12
LOCAL_STATIC_LIBRARIES :=

LOCAL_EXPORT_C_INCLUDES := $(LOCAL_PATH)

LOCAL_LDLIBS += -llog

include $(BUILD_SHARED_LIBRARY)
